# encoding: utf-8
# module cgitb
# from /System/Library/Frameworks/Python.framework/Versions/2.6/lib/python2.6/cgitb.pyo by generator 1.99
"""
More comprehensive traceback formatting for Python scripts.

To enable this module, do:

    import cgitb; cgitb.enable()

at the top of your script.  The optional arguments to enable() are:

    display     - if true, tracebacks are displayed in the web browser
    logdir      - if set, tracebacks are written to files in this directory
    context     - number of lines of source code to show for each stack frame
    format      - 'text' or 'html' controls the output format

By default, tracebacks are displayed but not saved, the context is 5 lines
and the output format is 'html' (for backwards compatibility with the
original use of this module)

Alternatively, if you have caught an exception and want cgitb to display it
for you, call cgitb.handler().  The optional argument to handler() is a
3-item tuple (etype, evalue, etb) just like the value of sys.exc_info().
The default handler displays output as HTML.
"""

# imports
import sys as sys # <module 'sys' (built-in)>

# Variables with simple values

__author__ = 'Ka-Ping Yee'

__version__ = '$Revision: 55348 $'

# functions

def enable(display=1, logdir=None, context=5, format=None): # reliably restored by inspect
    """
    Install an exception handler that formats tracebacks as HTML.
    
        The optional argument 'display' can be set to 0 to suppress sending the
        traceback to the browser, and 'logdir' can be set to a directory to cause
        tracebacks to be written to files there.
    """
    pass


def grey(text): # reliably restored by inspect
    # no doc
    pass


def handler(*args, **kwargs): # real signature unknown
    pass


def Hook(*args, **kwargs): # real signature unknown
    """ A hook to replace sys.excepthook that shows tracebacks in HTML. """
    pass


def html((etype, evalue, etb), context=5): # reliably restored by inspect
    """ Return a nice HTML document describing a given traceback. """
    pass


def lookup(name, frame, locals): # reliably restored by inspect
    """ Find the value for a given name in the given environment. """
    pass


def reset(): # reliably restored by inspect
    """ Return a string that resets the CGI and browser to a known state. """
    pass


def scanvars(reader, frame, locals): # reliably restored by inspect
    """ Scan one logical line of Python and look up values of variables used. """
    pass


def small(text): # reliably restored by inspect
    # no doc
    pass


def strong(text): # reliably restored by inspect
    # no doc
    pass


def text((etype, evalue, etb), context=5): # reliably restored by inspect
    """ Return a plain text document describing a given traceback. """
    pass


# no classes
# variables with complex values

__UNDEF__ = []

