# encoding: utf-8
# module lib2to3.fixer_util
# from /System/Library/Frameworks/Python.framework/Versions/2.6/lib/python2.6/lib2to3/fixer_util.pyo by generator 1.99
""" Utility functions, node construction macros, etc. """

# imports
import lib2to3.patcomp as patcomp # /System/Library/Frameworks/Python.framework/Versions/2.6/lib/python2.6/lib2to3/patcomp.pyc
import lib2to3.pgen2.token as token # /System/Library/Frameworks/Python.framework/Versions/2.6/lib/python2.6/lib2to3/pgen2/token.pyc
import lib2to3.pytree as __lib2to3_pytree


# Variables with simple values

p0 = "for_stmt< 'for' any 'in' node=any ':' any* >\n        | comp_for< 'for' any 'in' node=any any* >\n     "

p1 = "\npower<\n    ( 'iter' | 'list' | 'tuple' | 'sorted' | 'set' | 'sum' |\n      'any' | 'all' | (any* trailer< '.' 'join' >) )\n    trailer< '(' node=any ')' >\n    any*\n>\n"

p2 = "\npower<\n    'sorted'\n    trailer< '(' arglist<node=any any*> ')' >\n    any*\n>\n"

pats_built = False

# functions

def ArgList(args, lparen="Leaf(7, '(')", rparen="Leaf(8, ')')"): # reliably restored by inspect
    """ A parenthesised argument list, used by Call() """
    pass


def Assign(target, source): # reliably restored by inspect
    """ Build an assignment statement """
    pass


def Attr(obj, attr): # reliably restored by inspect
    """ A node tuple for obj.attr """
    pass


def attr_chain(obj, attr): # reliably restored by inspect
    """
    Follow an attribute chain.
    
        If you have a chain of objects where a.foo -> b, b.foo-> c, etc,
        use this to iterate over all objects in the chain. Iteration is
        terminated by getattr(x, attr) is None.
    
        Args:
            obj: the starting object
            attr: the name of the chaining attribute
    
        Yields:
            Each successive object in the chain.
    """
    pass


def BlankLine(): # reliably restored by inspect
    """ A blank line """
    pass


def Call(func_name, args=None, prefix=None): # reliably restored by inspect
    """ A function call """
    pass


def Comma(): # reliably restored by inspect
    """ A comma leaf """
    pass


def does_tree_import(package, name, node): # reliably restored by inspect
    """
    Returns true if name is imported from package at the
            top level of the tree which node belongs to.
            To cover the case of an import like 'import foo', use
            Null for the package and 'foo' for the name.
    """
    pass


def Dot(): # reliably restored by inspect
    """ A period (.) leaf """
    pass


def find_binding(name, node, package=None): # reliably restored by inspect
    """
    Returns the node which binds variable name, otherwise None.
            If optional argument package is supplied, only imports will
            be returned.
            See test cases for examples.
    """
    pass


def FromImport(package_name, name_leafs): # reliably restored by inspect
    """
    Return an import statement in the form:
            from package import name_leafs
    """
    pass


def in_special_context(node): # reliably restored by inspect
    """
    Returns true if node is in an environment where all that is required
            of it is being itterable (ie, it doesn't matter if it returns a list
            or an itterator).
            See test_map_nochange in test_fixers.py for some examples and tests.
    """
    pass


def is_list(node): # reliably restored by inspect
    """ Does the node represent a list literal? """
    pass


def is_tuple(node): # reliably restored by inspect
    """ Does the node represent a tuple literal? """
    pass


def KeywordArg(keyword, value): # reliably restored by inspect
    # no doc
    pass


def ListComp(xp, fp, it, test=None): # reliably restored by inspect
    """
    A list comprehension of the form [xp for fp in it if test].
    
        If test is None, the "if test" part is omitted.
    """
    pass


def LParen(): # reliably restored by inspect
    # no doc
    pass


def make_suite(node): # reliably restored by inspect
    # no doc
    pass


def Name(name, prefix=None): # reliably restored by inspect
    """ Return a NAME leaf """
    pass


def Newline(): # reliably restored by inspect
    """ A newline literal """
    pass


def Number(n, prefix=None): # reliably restored by inspect
    # no doc
    pass


def RParen(): # reliably restored by inspect
    # no doc
    pass


def String(string, prefix=None): # reliably restored by inspect
    """ A string leaf """
    pass


def Subscript(index_node): # reliably restored by inspect
    """ A numeric or string subscript """
    pass


def _find(name, node): # reliably restored by inspect
    # no doc
    pass


def _is_import_binding(node, name, package=None): # reliably restored by inspect
    """
    Will reuturn node if node will import name, or node
            will import * from package.  None is returned otherwise.
            See test cases for examples.
    """
    pass


# classes

class Leaf(__lib2to3_pytree.Base):
    """ Concrete implementation for leaf nodes. """
    def clone(self, *args, **kwargs): # real signature unknown
        """ Returns a cloned (deep) copy of self. """
        pass

    def get_prefix(self, *args, **kwargs): # real signature unknown
        """ Returns the prefix for the node. """
        pass

    def post_order(self, *args, **kwargs): # real signature unknown
        """ Returns a post-order iterator for the tree. """
        pass

    def pre_order(self, *args, **kwargs): # real signature unknown
        """ Returns a pre-order iterator for the tree. """
        pass

    def set_prefix(self, *args, **kwargs): # real signature unknown
        """ Sets the prefix for the node. """
        pass

    def _eq(self, *args, **kwargs): # real signature unknown
        """ Compares two nodes for equality. """
        pass

    def __init__(self, *args, **kwargs): # real signature unknown
        """
        Initializer.
        
                Takes a type constant (a token number < 256), a string value,
                and an optional context keyword argument.
        """
        pass

    def __repr__(self, *args, **kwargs): # real signature unknown
        """ Returns a canonical string representation. """
        pass

    def __str__(self, *args, **kwargs): # real signature unknown
        """
        Returns a pretty string representation.
        
                This reproduces the input source exactly.
        """
        pass

    column = 0
    lineno = 0
    prefix = ''


class Node(__lib2to3_pytree.Base):
    """ Concrete implementation for interior nodes. """
    def append_child(self, *args, **kwargs): # real signature unknown
        """
        Equivalent to 'node.children.append(child)'. This method also
                sets the child's parent attribute appropriately.
        """
        pass

    def clone(self, *args, **kwargs): # real signature unknown
        """ Returns a cloned (deep) copy of self. """
        pass

    def get_prefix(self, *args, **kwargs): # real signature unknown
        """
        Returns the prefix for the node.
        
                This passes the call on to the first child.
        """
        pass

    def insert_child(self, *args, **kwargs): # real signature unknown
        """
        Equivalent to 'node.children.insert(i, child)'. This method also
                sets the child's parent attribute appropriately.
        """
        pass

    def post_order(self, *args, **kwargs): # real signature unknown
        """ Returns a post-order iterator for the tree. """
        pass

    def pre_order(self, *args, **kwargs): # real signature unknown
        """ Returns a pre-order iterator for the tree. """
        pass

    def set_child(self, *args, **kwargs): # real signature unknown
        """
        Equivalent to 'node.children[i] = child'. This method also sets the
                child's parent attribute appropriately.
        """
        pass

    def set_prefix(self, *args, **kwargs): # real signature unknown
        """
        Sets the prefix for the node.
        
                This passes the responsibility on to the first child.
        """
        pass

    def _eq(self, *args, **kwargs): # real signature unknown
        """ Compares two nodes for equality. """
        pass

    def __init__(self, *args, **kwargs): # real signature unknown
        """
        Initializer.
        
                Takes a type constant (a symbol number >= 256), a sequence of
                child nodes, and an optional context keyword argument.
        
                As a side effect, the parent pointers of the children are updated.
        """
        pass

    def __repr__(self, *args, **kwargs): # real signature unknown
        """ Returns a canonical string representation. """
        pass

    def __str__(self, *args, **kwargs): # real signature unknown
        """
        Returns a pretty string representation.
        
                This reproduces the input source exactly.
        """
        pass


# variables with complex values

consuming_calls = None # (!) real value is ''

syms = None # (!) real value is ''

_block_syms = None # (!) real value is ''

_def_syms = None # (!) real value is ''

