# encoding: utf-8
# module runpy
# from /System/Library/Frameworks/Python.framework/Versions/2.6/lib/python2.6/runpy.pyo by generator 1.99
"""
runpy.py - locating and running Python code using the module namespace

Provides support for locating and running Python scripts using the Python
module namespace instead of the native filesystem.

This allows Python code to play nicely with non-filesystem based PEP 302
importers when locating support scripts as well as when importing modules.
"""

# imports
import sys as sys # <module 'sys' (built-in)>
import imp as imp # <module 'imp' (built-in)>

# functions

def get_loader(module_or_name): # reliably restored by inspect
    """
    Get a PEP 302 "loader" object for module_or_name
    
        If the module or package is accessible via the normal import
        mechanism, a wrapper around the relevant part of that machinery
        is returned.  Returns None if the module cannot be found or imported.
        If the named module is not already imported, its containing package
        (if any) is imported, in order to establish the package __path__.
    
        This function uses iter_importers(), and is thus subject to the same
        limitations regarding platform-specific special import locations such
        as the Windows registry.
    """
    pass


def run_module(mod_name, init_globals=None, run_name=None, alter_sys=False): # reliably restored by inspect
    """
    Execute a module's code without importing it
    
           Returns the resulting top level namespace dictionary
    """
    pass


def _get_filename(loader, mod_name): # reliably restored by inspect
    # no doc
    pass


def _get_module_details(mod_name): # reliably restored by inspect
    # no doc
    pass


def _run_code(code, run_globals, init_globals=None, mod_name=None, mod_fname=None, mod_loader=None, pkg_name=None): # reliably restored by inspect
    """ Helper for _run_module_code """
    pass


def _run_module_as_main(mod_name, set_argv0=True): # reliably restored by inspect
    """
    Runs the designated module in the __main__ namespace
    
           These __*__ magic variables will be overwritten:
               __file__
               __loader__
    """
    pass


def _run_module_code(code, init_globals=None, mod_name=None, mod_fname=None, mod_loader=None, pkg_name=None): # reliably restored by inspect
    """ Helper for run_module """
    pass


# no classes
# variables with complex values

__all__ = [
    'run_module',
]

