# encoding: utf-8
# module shutil
# from /System/Library/Frameworks/Python.framework/Versions/2.6/lib/python2.6/shutil.pyo by generator 1.99
"""
Utility functions for copying files and directory trees.

XXX The functions here don't copy the resource fork or other metadata on Mac.
"""

# imports
import stat as stat # /System/Library/Frameworks/Python.framework/Versions/2.6/lib/python2.6/stat.pyc
import sys as sys # <module 'sys' (built-in)>
import fnmatch as fnmatch # /System/Library/Frameworks/Python.framework/Versions/2.6/lib/python2.6/fnmatch.pyc
import os as os # /System/Library/Frameworks/Python.framework/Versions/2.6/lib/python2.6/os.pyc

# Variables with simple values

WindowsError = None

# functions

def abspath(path): # reliably restored by inspect
    """ Return an absolute path. """
    pass


def copy(src, dst): # reliably restored by inspect
    """
    Copy data and mode bits ("cp src dst").
    
        The destination may be a directory.
    """
    pass


def copy2(src, dst): # reliably restored by inspect
    """
    Copy data and all stat info ("cp -p src dst").
    
        The destination may be a directory.
    """
    pass


def copyfile(src, dst): # reliably restored by inspect
    """ Copy data from src to dst """
    pass


def copyfileobj(fsrc, fdst, length=16384): # reliably restored by inspect
    """ copy data from file-like object fsrc to file-like object fdst """
    pass


def copymode(src, dst): # reliably restored by inspect
    """ Copy mode bits from src to dst """
    pass


def copystat(src, dst): # reliably restored by inspect
    """ Copy all stat info (mode bits, atime, mtime, flags) from src to dst """
    pass


def copytree(src, dst, symlinks=False, ignore=None): # reliably restored by inspect
    """
    Recursively copy a directory tree using copy2().
    
        The destination directory must not already exist.
        If exception(s) occur, an Error is raised with a list of reasons.
    
        If the optional symlinks flag is true, symbolic links in the
        source tree result in symbolic links in the destination tree; if
        it is false, the contents of the files pointed to by symbolic
        links are copied.
    
        The optional ignore argument is a callable. If given, it
        is called with the `src` parameter, which is the directory
        being visited by copytree(), and `names` which is the list of
        `src` contents, as returned by os.listdir():
    
            callable(src, names) -> ignored_names
    
        Since copytree() is called recursively, the callable will be
        called once for each directory that is copied. It returns a
        list of names relative to the `src` directory that should
        not be copied.
    
        XXX Consider this example code rather than the ultimate tool.
    """
    pass


def destinsrc(src, dst): # reliably restored by inspect
    # no doc
    pass


def ignore_patterns(*patterns): # reliably restored by inspect
    """
    Function that can be used as copytree() ignore parameter.
    
        Patterns is a sequence of glob-style patterns
        that are used to exclude files
    """
    pass


def move(src, dst): # reliably restored by inspect
    """
    Recursively move a file or directory to another location. This is
        similar to the Unix "mv" command.
    
        If the destination is a directory or a symlink to a directory, the source
        is moved inside the directory. The destination path must not already
        exist.
    
        If the destination already exists but is not a directory, it may be
        overwritten depending on os.rename() semantics.
    
        If the destination is on our current filesystem, then rename() is used.
        Otherwise, src is copied to the destination and then removed.
        A lot more could be done here...  A look at a mv.c shows a lot of
        the issues this implementation glosses over.
    """
    pass


def rmtree(path, ignore_errors=False, onerror=None): # reliably restored by inspect
    """
    Recursively delete a directory tree.
    
        If ignore_errors is set, errors are ignored; otherwise, if onerror
        is set, it is called to handle the error with arguments (func,
        path, exc_info) where func is os.listdir, os.remove, or os.rmdir;
        path is the argument to that function that caused it to fail; and
        exc_info is a tuple returned by sys.exc_info().  If ignore_errors
        is false and onerror is None, an exception is raised.
    """
    pass


def _basename(path): # reliably restored by inspect
    # no doc
    pass


def _samefile(src, dst): # reliably restored by inspect
    # no doc
    pass


# classes

class Error(EnvironmentError):
    # no doc
    def __init__(self, *args, **kwargs): # real signature unknown
        pass

    __weakref__ = property(lambda self: object()) # default


# variables with complex values

__all__ = [
    'copyfileobj',
    'copyfile',
    'copymode',
    'copystat',
    'copy',
    'copy2',
    'copytree',
    'move',
    'rmtree',
    'Error',
]

